declare
[P Dom] = {Module.link ['parser.ozf' 'dom.ozf']}

% Build a Mozart structure for a simple xml string and test
declare
S = "<a id=\"1\">data<b id='2'/></a>"

% Test parsing xml string by:
% 1) Building a tree and browse it.
% 2) Converting the tree back to an xml string.
declare
D = {Object.new Dom.dom init}
{D loadXML(S)}
Tree = {D ozTree($)}
{Browse Tree}
% the tree is also stored in an object attr
{Browse {StringToAtom {D getXML($)}}}

% Build a Mozart structure for an RSS string and
% test using previous testing code
declare
S = "<?xml version=\"1.0\"?>
<rdf:RDF 
 xmlns=\"http://purl.org/rss/1.0/\"
 xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"
 xmlns:wn=\"http://xmlns.com/wordnet/1.6/\"
 xmlns:job=\"http://ilrt.org/discovery/2000/11/rss-query/jobvocab.rdf#\">

   <channel xmlns=\"http://sics.se\"
   rdf:about=\"http://ilrt.org/discovery/2000/11/rss-query/jobs-rss.rdf\">
            <title>A hypothetical job listings channel</title>
            <link>http://ilrt.org/discovery/2000/11/rss-query/</link>
            <description>
		This example shows RSS used as a lightweight data transport mechanism
            </description>

            <image rdf:resource=\"http://ilrt.org/discovery/2000/11/rss-query/joblogo.gif\"/>

            <items>
              <rdf:Seq>
                <rdf:li resource=\"http://example.com/job1.html\" />
                <rdf:li resource=\"http://example.com/job2.html\" />
              </rdf:Seq>
            </items>
      </channel>
          
          <image rdf:about=\"http://ilrt.org/discovery/2000/11/rss-query/joblogo.gif\">
            <title>RSS Job listing demo</title>
            <link>http://ilrt.org/discovery/2000/11/rss-query/</link>
            <url>http://ilrt.org/discovery/2000/11/rss-query/joblogo.gif</url>
          </image>
          
          <item rdf:about=\"http://example.com/job1.html\">
            <title>The title of job1 goes here</title>
            <link>http://example.com/job1.html</link>
            <description>
		(Job1-Job1-Job1...) A simple textual description of the
		job (ie. abstract of the job advert we reference) goes here.
            </description>
          
            <job:advertises>         
                 <wn:Job job:title=\"Job title for job1 goes here\"
			 job:salary=\"100000\"
			 job:currency=\"USD\"
			 >
			<job:orgHomepage rdf:resource=\"http://www.ukoln.ac.uk/\"/>
                  </wn:Job>
             </job:advertises>

          </item>

          <item rdf:about=\"http://example.com/job2.html\">
            <title>The title of job1 goes here</title>
            <link>http://example.com/job2.html</link>
            <description>
		(Job2-Job2-Job2...) A simple textual description of the
		job (ie. abstract of the job advert we reference) goes here.
            </description>

            <job:advertises>         
                 <wn:Job job:title=\"Job title for job2 goes here\"
			 job:salary=\"150000\"
			 job:currency=\"UKP\"
			 >
			<job:orgHomepage rdf:resource=\"http://ilrt.org/\"/>
                  </wn:Job>
             </job:advertises>
          </item>
</rdf:RDF>"

% Test building xml structure from scratch
declare
D = {Object.new Dom.dom init}
NameSpace = ''
N1 = {D addNode(0 a NameSpace "hello" $)}
N2 = {D addNode(N1 b NameSpace "" $)}
{D putNodeText(N2 "world")}
Tree = {D ozTree($)}
{Browse Tree}
{Browse {StringToAtom {D getXML($)}}}
{Browse {VirtualString.toAtom
	 {D getNodeText(N1 $)}#" "#
	 {D getNodeText(N2 $)}}}

% Exercises: write DOM methods that
% 1) adds attributes to a node
% 2) returns a namespace of a node
% 3) returns a basename of a node
